/**
 *  Copyright (C) 2010 Daniel Francisco de Melo, Tiago Teixeira
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Copyright (C) 2010 Daniel Francisco de Melo, Tiago Teixeira
 *
 *  Este programa é software livre; você pode redistribuí-lo e/ou
 *  modificá-lo sob os termos da Licença Pública Geral GNU, conforme
 *  publicada pela Free Software Foundation; tanto a versão 2 da
 *  Licença como (a seu critério) qualquer versão mais nova.
 *
 *  Este programa é distribuído na expectativa de ser útil, mas SEM
 *  QUALQUER GARANTIA; sem mesmo a garantia implícita de
 *  COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM
 *  PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais
 *  detalhes.
 *
 *  Você deve ter recebido uma cópia da Licença Pública Geral GNU
 *  junto com este programa; se não, escreva para a Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307, USA.
 */

package gui;

import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import protocolo.Mensagem;

public class Client extends Thread{

    ObjectOutputStream output;
    ObjectInputStream input;
    String message = "";
    String meuNome = "";
    private Principal p;
    private String ip;

    public Client(Principal pa,String ipchat) {
        this.p=pa;
        this.ip=ipchat;

    }

    @Override
    public void run() {
        Socket client;
        try {
           
            //cria o socket de conexão
          if(ip.equals("")){
                client = new Socket(InetAddress.getByName("127.0.0.1"), 1234);
            }else{

            client = new Socket(InetAddress.getByName(ip), 1234);
            }

            // recebe entrada e saida de fluxos.
            output = new ObjectOutputStream(
                    client.getOutputStream());
            output.flush();
            input = new ObjectInputStream(
                    client.getInputStream());
           
/*
 * fica esperando receber mensagens do servidor
 */
            Mensagem msg = null;
            do {
                try {
                    msg = (Mensagem) input.readObject();
                    p.enviarTexto(msg.texto);
              
                } catch (ClassNotFoundException cnfex) {
                    
                }
            } while (msg.codigo != 10);

            //se codigo da mensagem = 10 fecha a conexão
            
            output.close();
            input.close();
            client.close();
        } catch (EOFException eof) {
            System.out.println("Servidor encerrou a conexao");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void sendData(String s, int codigo) {
        try {
            message = s;
            Mensagem msg = new Mensagem(codigo, s);

            output.writeObject(msg);
            output.flush();
            output.reset();
             } catch (IOException ex) {
             }
    }


}