/**
 *  Copyright (C) 2010 Daniel Francisco de Melo, Tiago Teixeira
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Copyright (C) 2010 Daniel Francisco de Melo, Tiago Teixeira
 *
 *  Este programa é software livre; você pode redistribuí-lo e/ou
 *  modificá-lo sob os termos da Licença Pública Geral GNU, conforme
 *  publicada pela Free Software Foundation; tanto a versão 2 da
 *  Licença como (a seu critério) qualquer versão mais nova.
 *
 *  Este programa é distribuído na expectativa de ser útil, mas SEM
 *  QUALQUER GARANTIA; sem mesmo a garantia implícita de
 *  COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM
 *  PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais
 *  detalhes.
 *
 *  Você deve ter recebido uma cópia da Licença Pública Geral GNU
 *  junto com este programa; se não, escreva para a Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307, USA.
 */

package gui;

public class ComoJogar extends javax.swing.JDialog {

     private Principal pai;

   
    public ComoJogar(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.setLocationRelativeTo(parent);
        this.pai = (Principal) parent;
    }

    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane7 = new javax.swing.JScrollPane();
        jTextArea7 = new javax.swing.JTextArea();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextArea3 = new javax.swing.JTextArea();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTextArea4 = new javax.swing.JTextArea();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTextArea5 = new javax.swing.JTextArea();
        jScrollPane8 = new javax.swing.JScrollPane();
        jTextArea8 = new javax.swing.JTextArea();
        jScrollPane9 = new javax.swing.JScrollPane();
        jTextArea9 = new javax.swing.JTextArea();

        jTextArea7.setColumns(20);
        jTextArea7.setRows(5);
        jScrollPane7.setViewportView(jTextArea7);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Como Jogar");

        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setRows(5);
        jTextArea1.setText("Objetivo do Jogo\n\nO objetivo é capturar ou imobilizar as peças do adversário.\nO jogador que conseguir vence a partida.");
        jTextArea1.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jScrollPane1.setViewportView(jTextArea1);

        jTabbedPane1.addTab("Objetivo do jogo", jScrollPane1);

        jTextArea3.setColumns(20);
        jTextArea3.setEditable(false);
        jTextArea3.setRows(5);
        jTextArea3.setText("Movendo as Peças\n\nNo começo do jogo, suas peças ocupam todas as casas escuras no \nseu lado do tabuleiro. Quando for a sua vez de jogar, mova uma\ndas peças uma casa em direção ao lado do adversário.\nVocê deve deslocar-se para frente a fim de ocupar um espaço \nvazio, movendo-se uma casa na diagonal ou comendo a peça do \nadversário.\n\n\nPara mover uma peça:\n\nPosicione o ponteiro do mouse sobre a peça que você deseja \nmover.\nClique no botão do mouse para selecionar a peça.\nPosicione o ponteiro do mouse sobre a casa para a qual você\ndeseja mover a peça.\nClique no botão do mouse novamente para finalizar o movimento.\nEla será exibida na nova casa.\n\nObservação: se o movimento que você tentar fazer não for válido,\nsua peça não sairá da posição original.");
        jScrollPane3.setViewportView(jTextArea3);

        jTabbedPane1.addTab("Movendo as Peças", jScrollPane3);

        jTextArea4.setColumns(20);
        jTextArea4.setEditable(false);
        jTextArea4.setRows(5);
        jTextArea4.setText("Capturando as Peças\n\nSua peça pode capturar a peça do adversário para frente.\nQuando na casa subsequente a uma peça houver uma peça adversária, \ncom uma casa imediata vaga, na mesma diagonal, a peça \ncaptura-la-á passando para a citada casa vaga.\nAssim, a peça captura para a frente e para trás, sendo este o \núnico movimento retrógrado da peça. Se após a captura de uma \npeça a circunstância se repetir, a peça continuará a captura no\nmesmo lance, chamando-se a este movimento captura em cadeia.\nA captura é obrigatória.\nSe, no mesmo lance, se apresentar mais de um modo de capturar, é\nobrigatório executar o lance que capture o maior número de peças\n(lei da maioria).\nA peça que captura poderá passar mais de uma vez pela mesma casa\nvazia, porém não poderá capturar qualquer peça mais de uma vez. \n\n\nPara capturar com uma peça:\n\nPosicione o ponteiro do mouse sobre a peça que você deseja mover.\nClique no botão do mouse para selecionar a peça.\nPosicione o ponteiro do mouse sobre a casa oposta à peça do\nadversário.\nClique no botão do mouse novamente para finalizar o movimento.\nEla será exibida na casa de destino.\n\nObservação: se você puder fazer mais de uma captura em uma mesma\njogada, clique sobre a casa oposta a última pedra capturada.");
        jScrollPane4.setViewportView(jTextArea4);

        jTabbedPane1.addTab("Capturando as Peças", jScrollPane4);

        jTextArea5.setColumns(20);
        jTextArea5.setEditable(false);
        jTextArea5.setRows(5);
        jTextArea5.setText("Promovendo à Dama\n\nA peça que atingir a oitava casa adversária, parando ali, será \npromovida a dama.\nA dama é uma peça de movimentos mais amplos.\nA dama pode mover-se para trás e para frente em diagonal,\ndiferente das outras peças, que movimentam-se apenas para frente\nem diagonal.\nA dama pode também capturar uma peça pela frente ou por trás em\ndiagonal.\nSe, nas diagonais da casa de partida da dama, houver uma peça\nadversária cuja casa oposta esteja vaga, a dama captura-la-á\npassando para esta casa.\nA dama também captura em cadeia.\nA peça e a dama têm o mesmo valor para capturar ou ser capturada.\nNão será promovida a peça que, numa tomada em cadeia, apenas\npasse pela oitava casa adversária. As peças tomadas só deverão\nser retiradas do tabuleiro depois de completo o lance.\n\nObservação: quando uma peça alcança a borda oposta do tabuleiro,\nela é transformada automaticamente em uma dama, ou \"coroada\",\npelo jogo de damas. As damas são identificadas pela imagem de uma\ncoroa em cima do símbolo.");
        jScrollPane5.setViewportView(jTextArea5);

        jTabbedPane1.addTab("Promovendo à Dama", jScrollPane5);

        jTextArea8.setColumns(20);
        jTextArea8.setEditable(false);
        jTextArea8.setRows(5);
        jTextArea8.setText("Desistindo do Jogo \n\nQuando você desiste da partida, o jogo termina e o adversário\nvence. O adversário não tem a opção de aceitar ou recusar a\ndesistência.\n\nPara desistir de um jogo, clique no botão Desistir.");
        jScrollPane8.setViewportView(jTextArea8);

        jTabbedPane1.addTab("Desistindo do jogo ", jScrollPane8);

        jTextArea9.setColumns(20);
        jTextArea9.setEditable(false);
        jTextArea9.setRows(5);
        jTextArea9.setText("Estratégias e Dicas\n\nSeja o primeiro a capturar uma peça, depois force uma série de\ncapturas iguais. Você geralmente vencerá nessa situação. \nProcure oportunidades de capturar duas peças ao mesmo tempo. O\nadversário terá dificuldades para resgatá-las e isso enfraquecerá\nsua defesa. \nSacrifique estrategicamente uma peça para forçar uma captura \nmaior de peças do adversário. Por exemplo, deixe o adversário\ncapturar uma de suas peças se você puder usar a próxima posição\npara capturar duas peças dele. \nAo jogar na ofensiva, pense também na defensiva. Posicione suas\npeças para que possa responder a qualquer captura com uma\ncontra-captura. Tente não espalhar muito suas peças, pois isso\npossibilita que o adversário faça várias capturas. \nPense a longo prazo. Jogue para aumentar o número de movimentos\npossíveis na próxima vez e limite o número de movimentos do\nadversário. Você também pode usar sua peça estrategicamente para\nbloquear a peça do adversário e impedir que ela se mova para\nfrente.\nNão mova as peças da linha de trás muito cedo. Enquanto estiverem\nlá, o adversário não poderá fazer damas. Quando começar a mover\nas peças da linha de trás, comece com a primeira e a terceira a\npartir da esquerda. ");
        jScrollPane9.setViewportView(jTextArea9);

        jTabbedPane1.addTab("Estratégias e dicas", jScrollPane9);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 546, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 424, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

   

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea3;
    private javax.swing.JTextArea jTextArea4;
    private javax.swing.JTextArea jTextArea5;
    private javax.swing.JTextArea jTextArea7;
    private javax.swing.JTextArea jTextArea8;
    private javax.swing.JTextArea jTextArea9;
    // End of variables declaration//GEN-END:variables

}
