/**
 *  Copyright (C) 2010 Daniel Francisco de Melo, Tiago Teixeira
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Copyright (C) 2010 Daniel Francisco de Melo, Tiago Teixeira
 *
 *  Este programa é software livre; você pode redistribuí-lo e/ou
 *  modificá-lo sob os termos da Licença Pública Geral GNU, conforme
 *  publicada pela Free Software Foundation; tanto a versão 2 da
 *  Licença como (a seu critério) qualquer versão mais nova.
 *
 *  Este programa é distribuído na expectativa de ser útil, mas SEM
 *  QUALQUER GARANTIA; sem mesmo a garantia implícita de
 *  COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM
 *  PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais
 *  detalhes.
 *
 *  Você deve ter recebido uma cópia da Licença Pública Geral GNU
 *  junto com este programa; se não, escreva para a Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307, USA.
 */
package gui;

import java.awt.Color;
import java.awt.Graphics;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class Painel extends JPanel {

    private int selX, selY;
    private boolean preenchido;
    private Pecas[][] tabuleiro;
    private ImageIcon vermelha;
    public ImageIcon amarela;
    private ImageIcon Damarela;
    private ImageIcon Dvermelha;
    private ImageIcon SDamarela;
    private ImageIcon SDvermelha;
    private ImageIcon Svermelha;
    private ImageIcon Samarela;
    private boolean selec = false;
    private Logica logicaJogo;
    private boolean jogadorDaVez;
    public ImageIcon a;
    public ImageIcon b;
    public ImageIcon jabulani;
    private Principal pri;
    public int time1;
    public int time2;

    public Painel(Principal pa) {

        this.pri = pa;

    }
    /*
     * Desenha o tabuleiro na tela
     */

    public void desenhar() {
        Graphics g = this.getGraphics();

        for (int i = 0; i < 400; i += 50) {
            for (int j = 0; j < 400; j += 50) {
                if (this.preenchido == false) {
                    g.drawRect(i, j, 50, 50);
                } else {
                    g.fillRect(i, j, 50, 50);
                }
                // novo valor sera' igual ao antigo valor negado
                this.preenchido = !this.preenchido;
            }
            this.preenchido = !this.preenchido;
        }
    }
    /*
     * Preenche o tabuleiro com as peças
     */

    public void preencherPecas() {

        Graphics g = this.getGraphics();

        for (int lin = 0; lin
                < 8; lin++) {
            for (int col = 0; col
                    < 8; col++) {
                if (this.tabuleiro[lin][col] != null) {
                    if (tabuleiro[lin][col].isCor() == false) {
                        if (tabuleiro[lin][col].getDama() == true) {//se getDama true desenha a dama
                            g.drawImage(Dvermelha.getImage(), 50 * col + 10, 50 * lin, this);

                        } else {
                            g.drawImage(vermelha.getImage(), 50 * col + 10, 50 * lin + 10, this);

                        }
                    } else {
                        if (tabuleiro[lin][col].getDama() == true) {//se getDama true desenha a dama
                            g.drawImage(Damarela.getImage(), 50 * col + 10, 50 * lin, this);

                        } else {
                            g.drawImage(amarela.getImage(), 50 * col + 10, 50 * lin + 10, this);

                        }
                    }
                }
            }
        }
    }

    /*
     * Recebe linha e coluna que o jogador clicou
     * Se selec=false ainda não tem peça selecionada, então seleciona a peça indicada e guarda as coordenadas que esta selecionada
     */
    public void mover(int y, int x) {
        Graphics g = this.getGraphics();

        if (selec == false) {
            if (tabuleiro[x][y] != null) {
                if (tabuleiro[x][y].isCor() == this.jogadorDaVez) {
                    if (this.jogadorDaVez == true) {
                        if (this.tabuleiro[x][y].getDama() == true) {
                            g.fillRect(y * 50, x * 50, 50, 50);
                            g.drawImage(SDamarela.getImage(), 50 * y + 10, 50 * x, this);

                        } else {
                            g.fillRect(y * 50, x * 50, 50, 50);
                            g.drawImage(Samarela.getImage(), 50 * y + 10, 50 * x + 10, this);
                        }
                    } else {
                        if (this.tabuleiro[x][y].getDama() == true) {
                            g.fillRect(y * 50, x * 50, 50, 50);
                            g.drawImage(SDvermelha.getImage(), 50 * y + 10, 50 * x, this);
                        } else {
                            g.fillRect(y * 50, x * 50, 50, 50);
                            g.drawImage(Svermelha.getImage(), 50 * y + 10, 50 * x + 10, this);
                        }
                    }
                    selec = true;
                    selX = x;
                    selY = y;
                }
            }
        } else {//se ja estiver selecionada compara pra ver se não quer selecionar outra peça do jogador da vez
            if (tabuleiro[x][y] != null) {
                if (tabuleiro[x][y].isCor() == this.jogadorDaVez) {
                    this.desenhar();
                    this.preencherPecas();
                    if (this.jogadorDaVez == true) {
                        if (this.tabuleiro[x][y].getDama() == true) {
                            g.fillRect(y * 50, x * 50, 50, 50);
                            g.drawImage(SDamarela.getImage(), 50 * y + 10, 50 * x, this);

                        } else {
                            g.fillRect(y * 50, x * 50, 50, 50);
                            g.drawImage(Samarela.getImage(), 50 * y + 10, 50 * x + 10, this);
                        }
                    } else {
                        if (this.tabuleiro[x][y].getDama() == true) {
                            g.fillRect(y * 50, x * 50, 50, 50);
                            g.drawImage(SDvermelha.getImage(), 50 * y + 10, 50 * x, this);
                        } else {
                            g.fillRect(y * 50, x * 50, 50, 50);
                            g.drawImage(Svermelha.getImage(), 50 * y + 10, 50 * x + 10, this);
                        }
                    }
                    selec = true;
                    selX = x;
                    selY = y;
                }
            } else {//se cliclou em um lugar vazio invoca o método mover da classe lógica para ver se pode mover ou comer
                if (logicaJogo.mover(selX, selY, x, y) == 0) {
                    tabuleiro[x][y] = tabuleiro[selX][selY];
                    tabuleiro[selX][selY] = null;
                    selec = false;
                    this.historico(x, y);
                    this.jogadorDaVez = !this.jogadorDaVez;

                    this.desenhar();
                    this.preencherPecas();
                    selec = false;
                }

                this.testaVencedor();
                this.destino();
                this.origem();
                this.setJogador();
            }
        }
    }
    /*
     * Pega o destino da classe lógica e mostra para o jogador o destino quando obrigatório
     */

    public void destino() {
        String desenhardes = logicaJogo.deseDest();

        if (desenhardes.length() > 1) {
            JOptionPane.showMessageDialog(null, "Você deve comer a peça do adversário", "Atenção", JOptionPane.WARNING_MESSAGE);

            Graphics g = this.getGraphics();
            int q = 0, p = 0;

            for (int k = 0; k < desenhardes.length(); k += 2) {

                p = Integer.parseInt(desenhardes.substring(k, k + 1));
                q = Integer.parseInt(desenhardes.substring(k + 1, k + 2));

                g.setColor(Color.yellow);
                g.drawRoundRect(q * 50 + 5, p * 50 + 5, 40, 40, 5, 5);

            }
        }
    }
    /*
     * Mostra para o usuário a peça que tem que ser movida
     */

    public void origem() {
        String desenharori = logicaJogo.deseOrig();

        if (desenharori.length() > 1) {

            Graphics g = this.getGraphics();
            int q = 0, p = 0;

            for (int k = 0; k < desenharori.length(); k += 2) {

                p = Integer.parseInt(desenharori.substring(k, k + 1));
                q = Integer.parseInt(desenharori.substring(k + 1, k + 2));

                g.setColor(Color.yellow);
                g.drawRoundRect(q * 50 + 5, p * 50 + 5, 40, 40, 5, 5);

            }
        }
    }

    /*
     * envia para o Principal o jogador da vez para este indicar para o usuário
     */
    public void setJogador() {

        pri.jogador(jogadorDaVez);

    }
    /*
     * retorna o jogador da vez
     */

    public boolean getJogador() {
        return jogadorDaVez;
    }

    /*
     * testa para ver se existe vencedor
     * se acabou as peças ouve um vencedor, imprime na tela a mensagem de quem venceu
     */
    public void testaVencedor() {
        int z = 0, y = 0;
        for (int lin = 0; lin < 8; lin++) {
            for (int col = 0; col < 8; col++) {

                if (this.tabuleiro[lin][col] != null) {
                    if (this.tabuleiro[lin][col].isCor() == true) {
                        z++;

                    } else {
                        y++;
                    }
                }
            }
        }
        if (z == 0) {
            this.terminarJogo();
            this.pri.bloquearBotao();
            this.desenhar();
            JOptionPane.showMessageDialog(null, "        Jogador 2 venceu!", "Parabéns", JOptionPane.WARNING_MESSAGE);
        }
        if (y == 0) {
            this.terminarJogo();
            this.pri.bloquearBotao();
            this.desenhar();
            JOptionPane.showMessageDialog(null, "        Jogador 1 venceu!", "Parabéns", JOptionPane.WARNING_MESSAGE);
        }
    }

    /*
     * Histórico das jogadas, envia para o método seHistorico da Classe Principal enviar para a tela
     */
    public void historico(int x, int y) {

        String hist;
        int cor;

        if (jogadorDaVez == true) {
            hist = "Jogador 1 moveu: linha " + selX + " coluna " + selY + " \n                  para: linha " + x + " coluna " + y + "\n-------------------------------";
            cor = 1;
        } else {
            hist = "Jogador 2 moveu: linha " + selX + " coluna " + selY + " \n                  para: linha " + x + " coluna " + y + "\n-------------------------------";
            cor = 2;
        }
        this.pri.setHistorico(hist, cor);

    }
    /*
     * Inicio do jogo
     * Define quais os times
     * Cria o tabuleiro
     */

    public void Inicio(int t1, int t2) {
        int baixo, cima;

        baixo = t1;
        cima = t2;

        switch (baixo) {
            case 1:

                amarela = new ImageIcon(this.getClass().getResource("/imagens/avai.PNG"));
                Samarela = new ImageIcon(this.getClass().getResource("/imagens/avai_selec.PNG"));
                Damarela = new ImageIcon(this.getClass().getResource("/imagens/avai_dama.PNG"));
                SDamarela = new ImageIcon(this.getClass().getResource("/imagens/avai_dama_selec.PNG"));
                a = new ImageIcon(this.getClass().getResource("/imagens/avai_grande.png"));
                break;
            case 2:
                amarela = new ImageIcon(this.getClass().getResource("/imagens/figayra.PNG"));
                Samarela = new ImageIcon(this.getClass().getResource("/imagens/figayra_selec.PNG"));
                Damarela = new ImageIcon(this.getClass().getResource("/imagens/figayra_dama.PNG"));
                SDamarela = new ImageIcon(this.getClass().getResource("/imagens/figayra_dama_selec.PNG"));
                a = new ImageIcon(this.getClass().getResource("/imagens/figayra_grande.png"));
                break;
            case 3:
                amarela = new ImageIcon(this.getClass().getResource("/imagens/saopaulo.PNG"));
                Samarela = new ImageIcon(this.getClass().getResource("/imagens/saopaulo_selec.PNG"));
                Damarela = new ImageIcon(this.getClass().getResource("/imagens/saopaulo_dama.PNG"));
                SDamarela = new ImageIcon(this.getClass().getResource("/imagens/saopaulo_dama_selec.PNG"));
                a = new ImageIcon(this.getClass().getResource("/imagens/saopaulo_grande.png"));
                break;
        }
        switch (cima) {
            case 1:
                vermelha = new ImageIcon(this.getClass().getResource("/imagens/avai.PNG"));
                Svermelha = new ImageIcon(this.getClass().getResource("/imagens/avai_selec.PNG"));
                Dvermelha = new ImageIcon(this.getClass().getResource("/imagens/avai_dama.PNG"));
                SDvermelha = new ImageIcon(this.getClass().getResource("/imagens/avai_dama_selec.PNG"));
                b = new ImageIcon(this.getClass().getResource("/imagens/avai_grande.png"));
                break;
            case 2:
                vermelha = new ImageIcon(this.getClass().getResource("/imagens/figayra.PNG"));
                Svermelha = new ImageIcon(this.getClass().getResource("/imagens/figayra_selec.PNG"));
                Dvermelha = new ImageIcon(this.getClass().getResource("/imagens/figayra_dama.PNG"));
                SDvermelha = new ImageIcon(this.getClass().getResource("/imagens/figayra_dama_selec.PNG"));
                b = new ImageIcon(this.getClass().getResource("/imagens/figayra_grande.png"));
                break;
            case 3:
                vermelha = new ImageIcon(this.getClass().getResource("/imagens/saopaulo.PNG"));
                Svermelha = new ImageIcon(this.getClass().getResource("/imagens/saopaulo_selec.PNG"));
                Dvermelha = new ImageIcon(this.getClass().getResource("/imagens/saopaulo_dama.PNG"));
                SDvermelha = new ImageIcon(this.getClass().getResource("/imagens/saopaulo_dama_selec.PNG"));
                b = new ImageIcon(this.getClass().getResource("/imagens/saopaulo_grande.png"));
                break;
        }

        jabulani = new ImageIcon(this.getClass().getResource("/imagens/jabulani.PNG"));

        this.setBackground(Color.LIGHT_GRAY);
        this.preenchido = false;
        this.tabuleiro = new Pecas[8][8];
        this.selX = -1;
        this.selY = -1;

        for (int lin = 0; lin < 8; lin++) { //percorrendo linhas
            // determinando a cor da peca
            //false=vermelha
            boolean cor = (lin > 4) ? true : false;
            for (int col = 0; col < 8; col++) { //percorrendo colunas
                if ((lin != 3 && lin != 4) && (((lin % 2 == 0) && (col % 2 == 1)) || ((lin % 2 == 1) && (col % 2 == 0)))) {
                    this.tabuleiro[lin][col] = new Pecas(cor, false);
                }
            }
        }
        jogadorDaVez = true;
        this.logicaJogo = new Logica(tabuleiro);
    }

    /*
     * Percorre o tabuleiro apagando todas as peças
     */
    public void terminarJogo() {

        for (int i = 0; i < 8; i ++) {
            for (int j = 0; j < 8; j ++) {
                this.tabuleiro[i][j] = null;

            }
        }
    }
}
